From 4710827eba9d6c7bbee2cf2853ec418b08cc4100 Mon Sep 17 00:00:00 2001
From: Xue <xuechaojing@huawei.com>
Date: Mon, 13 May 2019 10:21:00 +0800
Subject: [PATCH 2764/2944] openeuler: net: hinic: delete address print

commit 399c0451dababb721cbc59e8b70152a8eaeab274 openEuler-1.0

driver inclusion
category:bugfix
bugzilla:4472
CVE:NA

------------------------------------------------------------------------

This patch deletes address print in hinic.

Reviewed-by: chiqijun <chiqijun@huawei.com>
Signed-off-by: Xue <xuechaojing@huawei.com>
Reviewed-by: Yang Yingliang <yangyingliang@huawei.com>
Signed-off-by: Yang Yingliang <yangyingliang@huawei.com>
Signed-off-by: Xin Hao <haoxing990@gmail.com>
Reviewed-by: Baolin Wang <baolin.wang@openanolis.org>
---
 drivers/net/ethernet/huawei/hinic/hinic_cmdq.c        | 6 ++----
 drivers/net/ethernet/huawei/hinic/hinic_dbgtool_knl.c | 7 +++----
 drivers/net/ethernet/huawei/hinic/hinic_hwif.c        | 1 -
 drivers/net/ethernet/huawei/hinic/hinic_nictool.c     | 7 +++----
 4 files changed, 8 insertions(+), 13 deletions(-)

diff --git a/drivers/net/ethernet/huawei/hinic/hinic_cmdq.c b/drivers/net/ethernet/huawei/hinic/hinic_cmdq.c
index 5cb7cb3..e9f9f0a 100644
--- a/drivers/net/ethernet/huawei/hinic/hinic_cmdq.c
+++ b/drivers/net/ethernet/huawei/hinic/hinic_cmdq.c
@@ -278,8 +278,7 @@ void hinic_free_cmd_buf(void *hwdev, struct hinic_cmd_buf *cmd_buf)
 	struct hinic_cmdqs *cmdqs;
 
 	if (!hwdev || !cmd_buf) {
-		pr_err("Failed to free cmd buf: hwdev: %p, cmd_buf: %p\n",
-		       hwdev, cmd_buf);
+		pr_err("Failed to free cmd buf.\n");
 		return;
 	}
 
@@ -892,8 +891,7 @@ static int cmdq_set_arm_bit(struct hinic_cmdq *cmdq, void *buf_in, u16 in_size)
 static int cmdq_params_valid(void *hwdev, struct hinic_cmd_buf *buf_in)
 {
 	if (!buf_in || !hwdev) {
-		pr_err("Invalid CMDQ buffer addr: %p or hwdev: %p\n",
-		       buf_in, hwdev);
+		pr_err("Invalid CMDQ buffer addr\n");
 		return -EINVAL;
 	}
 
diff --git a/drivers/net/ethernet/huawei/hinic/hinic_dbgtool_knl.c b/drivers/net/ethernet/huawei/hinic/hinic_dbgtool_knl.c
index 82f1ec3..ff43c04 100644
--- a/drivers/net/ethernet/huawei/hinic/hinic_dbgtool_knl.c
+++ b/drivers/net/ethernet/huawei/hinic/hinic_dbgtool_knl.c
@@ -116,7 +116,7 @@ int hinic_mem_mmap(struct file *filp, struct vm_area_struct *vma)
 	}
 
 	if (offset && offset != g_card_phy_addr[card_id]) {
-		pr_err("offset is invalid, offset addr %llx\n", offset);
+		pr_err("offset is invalid\n");
 		return -EAGAIN;
 	}
 	/* old version of tool set vma->vm_pgoff to 0 */
@@ -280,7 +280,7 @@ void chipif_get_all_pf_dev_info(struct pf_dev_info *dev_info, int card_idx,
 	struct hinic_hwdev *hwdev;
 
 	if (!dev_info) {
-		pr_err("Params error! dev_info:%p\n", dev_info);
+		pr_err("Params error!\n");
 		return;
 	}
 
@@ -341,8 +341,7 @@ long dbgtool_knl_pf_dev_info_get(struct dbgtool_param *para,
 		g_card_phy_addr[card_id] =
 			virt_to_phys(g_card_vir_addr[card_id]);
 		if (!g_card_phy_addr[card_id]) {
-			pr_err("phy addr for card %d is 0, vir_addr: 0x%llx\n",
-			       card_id, g_card_vir_addr[card_id]);
+			pr_err("phy addr for card %d is 0\n", card_id);
 			free_pages((unsigned long)g_card_vir_addr[card_id],
 				   DBGTOOL_PAGE_ORDER);
 			g_card_vir_addr[card_id] = NULL;
diff --git a/drivers/net/ethernet/huawei/hinic/hinic_hwif.c b/drivers/net/ethernet/huawei/hinic/hinic_hwif.c
index def8c2b..fad2d6d 100644
--- a/drivers/net/ethernet/huawei/hinic/hinic_hwif.c
+++ b/drivers/net/ethernet/huawei/hinic/hinic_hwif.c
@@ -552,7 +552,6 @@ int hinic_init_hwif(struct hinic_hwdev *hwdev, void *cfg_reg_base,
 
 	hwif->cfg_regs_base = cfg_reg_base;
 	hwif->intr_regs_base = intr_reg_base;
-	pr_info("init intr_regs_base=%p", hwif->intr_regs_base);
 
 	hwif->db_base_phy = db_base_phy;
 	hwif->db_base = db_base;
diff --git a/drivers/net/ethernet/huawei/hinic/hinic_nictool.c b/drivers/net/ethernet/huawei/hinic/hinic_nictool.c
index 387752b..936c1e5 100644
--- a/drivers/net/ethernet/huawei/hinic/hinic_nictool.c
+++ b/drivers/net/ethernet/huawei/hinic/hinic_nictool.c
@@ -1025,8 +1025,8 @@ static int __get_card_usr_api_chain_mem(int card_idx)
 			(void *)__get_free_pages(GFP_KERNEL,
 						 DBGTOOL_PAGE_ORDER);
 		if (!g_card_vir_addr[card_idx]) {
-			pr_err("Alloc api chain memory fail for card %d, virt_addr: %p!\n",
-			       card_idx, g_card_vir_addr[card_idx]);
+			pr_err("Alloc api chain memory fail for card %d.\n",
+			       card_idx);
 			mutex_unlock(&g_addr_lock);
 			return -EFAULT;
 		}
@@ -1037,8 +1037,7 @@ static int __get_card_usr_api_chain_mem(int card_idx)
 		g_card_phy_addr[card_idx] =
 			virt_to_phys(g_card_vir_addr[card_idx]);
 		if (!g_card_phy_addr[card_idx]) {
-			pr_err("phy addr for card %d is 0, vir_addr: 0x%p\n",
-			       card_idx, g_card_vir_addr[card_idx]);
+			pr_err("phy addr for card %d is 0.\n", card_idx);
 			free_pages((unsigned long)g_card_vir_addr[card_idx],
 				   DBGTOOL_PAGE_ORDER);
 			g_card_vir_addr[card_idx] = NULL;
-- 
1.8.3.1