From f6e7ab0ae2c408a53f6b39ff1be28d9f1a431007 Mon Sep 17 00:00:00 2001
From: Xue <xuechaojing@huawei.com>
Date: Mon, 20 May 2019 20:58:42 +0800
Subject: [PATCH 2766/2944] openeuler: net: hinic: cleanup comments

commit 4ffac0d4d1abdf82976efe53ca87961fc668b838 openEuler-1.0

driver inclusion
category:bugfix
bugzilla:4472
CVE:NA

------------------------------------------------------------------------

This patch cleanup usless comments.

Reviewed-by: chiqijun <chiqijun@huawei.com>
Signed-off-by: Xue <xuechaojing@huawei.com>
Reviewed-by: Yang Yingliang <yangyingliang@huawei.com>
Signed-off-by: Yang Yingliang <yangyingliang@huawei.com>
Signed-off-by: Xin Hao <haoxing990@gmail.com>
Reviewed-by: Baolin Wang <baolin.wang@openanolis.org>
---
 drivers/net/ethernet/huawei/hinic/hinic_cfg.c   | 2 --
 drivers/net/ethernet/huawei/hinic/hinic_cfg.h   | 2 +-
 drivers/net/ethernet/huawei/hinic/hinic_hwdev.c | 5 ++---
 drivers/net/ethernet/huawei/hinic/hinic_lld.c   | 2 +-
 drivers/net/ethernet/huawei/hinic/hinic_tx.c    | 2 +-
 5 files changed, 5 insertions(+), 8 deletions(-)

diff --git a/drivers/net/ethernet/huawei/hinic/hinic_cfg.c b/drivers/net/ethernet/huawei/hinic/hinic_cfg.c
index 3684f9a..fbacba1 100644
--- a/drivers/net/ethernet/huawei/hinic/hinic_cfg.c
+++ b/drivers/net/ethernet/huawei/hinic/hinic_cfg.c
@@ -711,9 +711,7 @@ static void rdma_param_fix(struct hinic_hwdev *dev)
 	rdma_cap->max_gid_per_port = MAX_GID_PER_PORT;
 	rdma_cap->gid_entry_sz = GID_ENTRY_SZ;
 	rdma_cap->reserved_lkey = RSVD_LKEY;
-	/* start */
 	rdma_cap->num_comp_vectors = (u32)dev->cfg_mgmt->eq_info.num_ceq;
-	/* end */
 	rdma_cap->page_size_cap = PAGE_SZ_CAP;
 	rdma_cap->flags = (RDMA_BMME_FLAG_LOCAL_INV |
 			   RDMA_BMME_FLAG_REMOTE_INV |
diff --git a/drivers/net/ethernet/huawei/hinic/hinic_cfg.h b/drivers/net/ethernet/huawei/hinic/hinic_cfg.h
index b31c624..55d0383 100644
--- a/drivers/net/ethernet/huawei/hinic/hinic_cfg.h
+++ b/drivers/net/ethernet/huawei/hinic/hinic_cfg.h
@@ -122,7 +122,7 @@ enum {
 
 #define LOCAL_ACK_DELAY     15
 #define RDMA_NUM_PORTS      1
-#define ROCE_MAX_MSG_SZ     (2 * G_UNIT) /*  */
+#define ROCE_MAX_MSG_SZ     (2 * G_UNIT)
 #define IWARP_MAX_MSG_SZ    (1 * G_UNIT)
 
 #define DB_PAGE_SZ          (4 * K_UNIT)
diff --git a/drivers/net/ethernet/huawei/hinic/hinic_hwdev.c b/drivers/net/ethernet/huawei/hinic/hinic_hwdev.c
index 74582e6..86e6da1 100644
--- a/drivers/net/ethernet/huawei/hinic/hinic_hwdev.c
+++ b/drivers/net/ethernet/huawei/hinic/hinic_hwdev.c
@@ -1434,7 +1434,6 @@ static int hinic_vf_rx_tx_flush_in_pf(struct hinic_hwdev *hwdev, u16 vf_id)
 			ret = -EFAULT;
 	}
 
-	/* wait ucode stop I/O */
 	msleep(100);
 
 	/* notice up begine vf flush */
@@ -1467,7 +1466,7 @@ static int hinic_pf_rx_tx_flush(struct hinic_hwdev *hwdev)
 	int err;
 	int ret = 0;
 
-	/*  wait ucode stop I/O */
+	/* wait ucode stop I/O */
 	msleep(100);
 
 	err = wait_cmdq_stop(hwdev);
@@ -4399,7 +4398,7 @@ static u8 hinic_get_heartbeat_status(struct hinic_hwdev *hwdev)
 		sdk_err(hwdev->dev_hdl, "Detect pcie is link down\n");
 		hinic_set_chip_absent(hwdev);
 		hinic_force_complete_all(hwdev);
-	/* :should notify chiperr to pangea
+	/* should notify chiperr to pangea
 	 * when detecting pcie link down
 	 */
 		return 1;
diff --git a/drivers/net/ethernet/huawei/hinic/hinic_lld.c b/drivers/net/ethernet/huawei/hinic/hinic_lld.c
index 86e499d..4260ed4 100644
--- a/drivers/net/ethernet/huawei/hinic/hinic_lld.c
+++ b/drivers/net/ethernet/huawei/hinic/hinic_lld.c
@@ -1923,7 +1923,7 @@ static int mapping_bar(struct pci_dev *pdev, struct hinic_pcidev *pci_adapter)
 
 	dwqe_addr = pci_adapter->db_base_phy + HINIC_DB_DWQE_SIZE;
 
-	/* arm do not support call ioremap_wc(), refer to  */
+	/* arm do not support call ioremap_wc() */
 	pci_adapter->dwqe_mapping = __ioremap(dwqe_addr, HINIC_DB_DWQE_SIZE,
 					      __pgprot(PROT_DEVICE_nGnRnE));
 	if (!pci_adapter->dwqe_mapping) {
diff --git a/drivers/net/ethernet/huawei/hinic/hinic_tx.c b/drivers/net/ethernet/huawei/hinic/hinic_tx.c
index 276e449..0088acc 100644
--- a/drivers/net/ethernet/huawei/hinic/hinic_tx.c
+++ b/drivers/net/ethernet/huawei/hinic/hinic_tx.c
@@ -804,7 +804,7 @@ static netdev_tx_t hinic_send_one_skb(struct sk_buff *skb,
 
 	num_sge = skb_nr_frags + 1;
 
-	/* :if skb->len is more than 65536B but num_sge is 1,
+	/* if skb->len is more than 65536B but num_sge is 1,
 	 * driver will drop it
 	 */
 	if (unlikely(skb->len > HINIC_GSO_MAX_SIZE && num_sge == 1)) {
-- 
1.8.3.1